Erstellt vor 6 Jahren

Zuletzt geändert vor 5 Monaten

#1939 new task

Toolchain updates: binutils, gcc, uClibc, etc.

Erstellt von: cuma Verantwortlicher:
Priorität: normal Meilenstein: freetz-future
Komponente: toolchain Version: devel
Stichworte: Beobachter:
Product Id: Firmware Version:

Beschreibung

Fortsetzung von #1517

Hier werden alle Patches und Commits gesammelt, die die Toolchains betreffen.

Anhänge (4)

0001-toolchain-update-gcc-4.8.x-version-to-4.8.3.patch (73.5 KB) - hinzugefügt von dileks vor 4 Jahren.
[PATCH] toolchain: update gcc-4.8.x version to 4.8.3
freetz-config_gcc-4-8-3_dileks.txt (57.8 KB) - hinzugefügt von dileks vor 4 Jahren.
My Freetz-config to test gcc-4.8.3 (dileks)
0001-toolchain-gcc-4.8.3-Fix-000-no_target_flags_as_BUILD.patch (1.3 KB) - hinzugefügt von dileks vor 4 Jahren.
[PATCH] toolchain: gcc-4.8.3: Fix 000-no_target_flags_as_BUILD_FLAGS.freetz.patch
0001-toolchain-update-gcc-4.8.x-version-to-4.8.3-v2.patch (73.6 KB) - hinzugefügt von dileks vor 4 Jahren.
[PATCH] toolchain: update gcc-4.8.x version to 4.8.3 (v2)

Alle Anhänge herunterladen als: .zip

Änderungshistorie (167)

comment:1 Geändert vor 6 Jahren durch er13

In 9601:

binutils:

  • remove unnecessary/unused mips_non_pic.patch
  • refs #1517, refs #1939

The removed patch added support for -mnon-pic-abicalls option to the assembler (as). All recent gcc-versions (actually all since 2008) do not pass this flag to the assembler anymore and use -call_nonpic to achieve the same result (mips_pic = NO_PIC; mips_abicalls = TRUE;). -call_nonpic is officially supported by recent binutils versions → unnecessary/unused patch.

comment:2 Geändert vor 6 Jahren durch er13

Reminder: In den uClibc-0.9.32-basierten Firmwares ist libubacktrace (uClibc-library) enthalten. Momentan scheint AVM diese nicht zu nutzen. Sollte sich dies ändern, so muss uClibc .config angepasst und die Library aufgenommen werden.

comment:3 Geändert vor 6 Jahren durch er13

In 9983:

menuconfig:

  • add support for override options for download toolchains
  • refs #1939
  • refs #1999

From now on one can build his own toolchains and use them as download toolchains by overriding the corresponding options under "Override options/Override precompiled toolchain options":

  1. activate "Toolchain options/Build own toolchains"
  2. set toolchain related options to the desired ones under "Toolchain options"
  3. (optional) make your own modifications under $(freetz_root)/toolchain
  4. call "make KTV=freetz-${MY_VERSION}-${MY_SUFFIX} TTV=freetz-${MY_VERSION}-${MY_SUFFIX} toolchain"
  5. wait the build to complete
  6. (optional) upload created download toolchain files to some site

The toolchains created in steps above can then be reused:

  1. activate "Toolchain options/Download and use precompiled toolchains"
  2. activate "Override options/Override precompiled toolchain options"
  3. set version/suffix/md5/download-site values to the values used in the steps above
  1. adjust gcc/uClibc versions under "Toolchain options", set them to the same values as in step 2

comment:4 Geändert vor 6 Jahren durch er13

Interessanter openwrt commit (-ffunction-sections, -fdata-sections and —gc-sections)

comment:5 Geändert vor 6 Jahren durch er13

In 9989:

  • make "IPv6 support" selectable in FREETZ_DL_TOOLCHAIN_OVERRIDE mode (aka self-built toolchain as download-toolchain). The (expert) user is solely responsible for its proper configuration according to the setting used while building the download-toolchain used.
  • refs r9983, refs #1939, refs #1999

comment:6 Geändert vor 6 Jahren durch er13

In 9998:

  • Switch the default value of "Use reduced set of locales"-option to y.
  • Remove all values mathing the default ones from build_download_toolchains-script. The only difference between the default values and the values used to build download toolchains is the value of "Build 32-bit toolchains-option.
  • refs #1939

comment:7 Geändert vor 5 Jahren durch er13

In 10350:

gcc-4.7.x:

  • bump version to 4.7.3
  • refs #1939

comment:8 Geändert vor 5 Jahren durch er13

In 10352:

toolchain:

  • add support for binutils-2.23.x
  • refs #1939

comment:9 Geändert vor 5 Jahren durch er13

In 10356:

gcc for target:

  • remove unnecessary variable, it's unused, CC is overridden via TARGET_CONFIGURE_ENV (in case CC was actually meant and not GCC)
  • refs #1939

comment:10 Geändert vor 5 Jahren durch er13

In 10357:

gcc:

  • remove unnecessary debug flag
  • refs #1939

comment:11 Geändert vor 5 Jahren durch er13

In 10358:

gcc for kernel:

  • remove ifdef became unnecessary after removing gcc-4.4.x support in r9481
  • refs #1939

comment:12 Geändert vor 5 Jahren durch er13

In 10359:

gcc for kernel:

comment:13 Geändert vor 5 Jahren durch er13

In 10360:

binutils:

  • mark binutils-2.23.x as EXPERIMENTAL, kernel-2.6.28 doesn't compile with it
  • refs #1939

comment:14 Geändert vor 5 Jahren durch er13

In 10361:

binutils:

  • mark support for binutils-2.23.x as EXPERIMENTAL in changelog too
  • refs #1939

comment:15 Geändert vor 5 Jahren durch er13

In 10371:

target toolchain:

  • add preliminary and HIGHLY EXPERIMENTAL support for gcc-4.8.x
  • gcc for target doesn't compile and thus not available (probable cause - GCC's switch to C++ as implementation language)
  • a lot of new (sometimes somewhat pointless) warnings
  • some packages may not compile
  • compile-tested only
  • refs #1939

DON'T USE IT ON ANY PRODUCTIVE BOX, BE READY TO RECOVER YOUR BOX… you've been warned!

comment:16 Geändert vor 5 Jahren durch er13

In 10380:

toolchain:

  • bump gcc-4.6.x version to 4.6.4 (self-built toolchain only)
  • download-toolchain is still 4.6.3 even if menuconfig says 4.6.4 (will also be updated to 4.6.4 within the next couple of days)
  • refs #1939
  • refs #2072

comment:17 Geändert vor 5 Jahren durch er13

In 10381:

comment:18 Geändert vor 5 Jahren durch er13

In 10382:

download-toolchain:

NO-AUTOUPDATE-WARNING: all users must either start with a fresh checkout or backup their .config and call "make distclean" after updating to this revision.

comment:19 Geändert vor 5 Jahren durch cuma

In 10390:

[freetz-2.0] merge (refs #2072)

r10389 | Whoopie | 2013-04-16 10:12:36 GMT+01:00

privoxy: set executable bit for privoxy_log.cgi (closes #2045, refs #2072)


r10387 | cuma | 2013-04-16 01:44:20 GMT+01:00

firmware bump: 7360int 111.05.51 rev25025 (refs #2072)


r10382 | er13 | 2013-04-15 11:18:05 GMT+01:00

download-toolchain:

NO-AUTOUPDATE-WARNING: all users must either start with a fresh checkout or backup their .config and call "make distclean" after updating to this revision.


r10381 | er13 | 2013-04-14 22:02:18 GMT+01:00


r10380 | er13 | 2013-04-14 20:46:38 GMT+01:00

toolchain:

  • bump gcc-4.6.x version to 4.6.4 (self-built toolchain only)
  • download-toolchain is still 4.6.3 even if menuconfig says 4.6.4 (will also be updated to 4.6.4 within the next couple of days)
  • refs #1939
  • refs #2072

comment:20 Geändert vor 5 Jahren durch er13

In 10392:

toolchain/gcc-4.8.x:

  • make gcc-for-target compile, enable it in menuconfig
  • refs #1939

comment:21 Geändert vor 5 Jahren durch er13

In 10393:

toolchain:

  • autofix gcc-4.8 patches
  • refs #1939

comment:22 Geändert vor 5 Jahren durch er13

In 10398:

binutils for target:

comment:23 Geändert vor 5 Jahren durch er13

In 10450:

binutils-2.23:

  • remove EXPERIMENTAL from target-toolchain related part of menuconfig
  • binutils-2.23 for kernel-toolchain is still EXPERIMENTAL
  • refs #1939, refs #2086

comment:24 Geändert vor 5 Jahren durch er13

In 10507:

toolchain:

  • disable download-toolchain for 7390 labor firmware - AVM has updated uClibc version
  • refs #2103, refs #1939

comment:25 Geändert vor 5 Jahren durch er13

In 10508:

toolchain:

  • preparation step for adding support for uClibc-0.9.33.x/gcc-4.7.x based boxes
  • refs #2103, refs #1939
  • menuconfig-tested only

comment:26 Geändert vor 5 Jahren durch er13

In 10509:

gmp:

  • bump version to 5.1.2
  • refs #1939

comment:27 Geändert vor 5 Jahren durch er13

In 10510:

gcc-4.7.x:

  • add patch fixing kernel miscompilation (patch taken from openwrt)
  • refs #1939

comment:28 Geändert vor 5 Jahren durch er13

In 10511:

toolchain:

  • provide download-toolchain for uClibc-0.9.33.x/gcc-4.7.x based firmwares
  • refs #2103, refs #1939

comment:29 Geändert vor 5 Jahren durch er13

In 10517:

  • rename FREETZ_UCLIBC_0_9_XX_BASED_BOX to FREETZ_AVM_UCLIBC_0_9_XX
  • refs #1939

comment:30 Geändert vor 5 Jahren durch er13

In 10518:

  • rename FREETZ_GCC_X_Y_COMPILED_KERNEL to FREETZ_AVM_GCC_X_Y
  • refs #1939

comment:31 Geändert vor 5 Jahren durch er13

In 10519:

  • rename FREETZ_TARGET_UCLIBC_VERSION_0_9_XX to FREETZ_TARGET_UCLIBC_0_9_XX (counterpart to FREETZ_AVM_UCLIBC_0_9_XX)
  • refs #1939

comment:32 Geändert vor 5 Jahren durch er13

In 10520:

  • rename FREETZ_KERNEL_COMPILER_GCC_X_Y to FREETZ_KERNEL_GCC_X_Y
  • refs #1939

comment:33 Geändert vor 5 Jahren durch er13

In 10521:

  • rename FREETZ_TARGET_COMPILER_GCC_X_Y to FREETZ_TARGET_GCC_X_Y
  • refs #1939

comment:34 Geändert vor 5 Jahren durch er13

In 10523:

  • move original firmware related menuconfig symbols to Config.in.has_avm
  • refs #1939

comment:35 Geändert vor 5 Jahren durch er13

In 10524:

uClibc:

  • add support for firmwares using NPTL enabled uClibc
  • refs #2103, refs #1939

comment:36 Geändert vor 5 Jahren durch er13

In 10525:

toolchain:

  • disable download-toolchain for uClibc-0.9.33.x based firmwares (the one provided in r10511 doesn't work)
  • refs #2103, refs #1939

comment:37 Geändert vor 5 Jahren durch er13

In 10526:

uClibc:

  • remove unnecessary menuconfig symbol, rename uClibc-configs accordingly
  • refs #1939

comment:38 Geändert vor 5 Jahren durch er13

In 10527:

uClibc:

  • consider target uClibc version while trying to enable/disable NPTL support
  • refs #1939, refs r10524

comment:39 Geändert vor 5 Jahren durch er13

In 10528:

uClibc:

  • add support for libubacktrace required for uClibc-0.9.33.x based firmwares
  • menuconfig-tested only
  • refs #2103, refs #1939

comment:40 Geändert vor 5 Jahren durch Whoopie

Eigene Toolchain baut hier nicht:

make[3]: Nothing to be done for `locale_headers'.
rm -f lib/libc.so lib/libc.so.0 lib/libuClibc-0.9.33.2.so
/home/whoopie/misc/freetz/freetz-trunk-7390/toolchain/build/mips_gcc-4.7.3_uClibc-0.9.33.2/mips-linux-uclibc/bin/mips-linux-uclibc-gcc -Wl,-EB -Wl,-melf32btsmip -shared -Wl,--warn-common -Wl,--warn-once -Wl,-z,combreloc -Wl,-z,relro -Wl,-z,defs   -Wl,-init,__uClibc_init  -Wl,-soname=libc.so.0 -nostdlib -o lib/libuClibc-0.9.33.2.so  -Wl,--whole-archive libc/libc_so.a -Wl,--no-whole-archive ./lib/interp.os ./lib/ld-uClibc.so.0 ./lib/uclibc_nonshared.a /home/whoopie/misc/freetz/freetz-trunk-7390/toolchain/build/mips_gcc-4.7.3_uClibc-0.9.33.2/mips-linux-uclibc/bin/../lib/gcc/mips-linux-uclibc/4.7.3/libgcc.a 
libc/libc_so.a(brk.os): In function `brk':
brk.c:(.text+0x40): undefined reference to `__emutls_v.__libc_errno'
libc/libc_so.a(__h_errno_location.os): In function `__h_errno_location':
__h_errno_location.c:(.text+0x14): undefined reference to `__emutls_v.__libc_h_errno'
libc/libc_so.a(res_data.os): In function `__res_mkquery':
res_data.c:(.text+0xb0): undefined reference to `__emutls_v.__libc_resp'
collect2: error: ld returned 1 exit status
make[1]: *** [lib/libc.so] Fehler 1
make[1]: Verlasse Verzeichnis '/home/whoopie/misc/freetz/freetz-trunk-7390/source/toolchain-mips_gcc-4.7.3_uClibc-0.9.33.2/uClibc-0.9.33.2'
make: *** [/home/whoopie/misc/freetz/freetz-trunk-7390/toolchain/build/mips_gcc-4.7.3_uClibc-0.9.33.2/mips-linux-uclibc/usr/lib/libc.a] Fehler 2

comment:41 Geändert vor 5 Jahren durch er13

In 10529:

uClibc:

  • document the origin of 904-pthread_errno_fix.patch
  • refs #1939

comment:42 Geändert vor 5 Jahren durch er13

In 10530:

uClibc:

  • provide more information on 904-pthread_errno_fix.patch
  • refs #1939

comment:43 Geändert vor 5 Jahren durch er13

In 10531:

gcc:

comment:44 Geändert vor 5 Jahren durch er13

In 10532:

uClibc:

  • add patch fixing libubacktrace name in the libc linker script
  • fixes "mips-linux-uclibc/bin/ld: cannot find …/libubacktrace.so.0 inside …"-problem
  • refs #1939, refs r10528

comment:45 Geändert vor 5 Jahren durch er13

In 10533:

uClibc:

  • replace pthread_errno_fix-patch with a better one taken from Buildroot
  • more information can be found here
  • refs #1939

comment:46 Geändert vor 5 Jahren durch er13

In 10534:

toolchain:

  • LinuxThreads- and NPTL-based toolchains are not compatible with each other ⇒ put them in different directories
  • refs #1939

comment:47 Geändert vor 5 Jahren durch er13

In 10535:

uClibc/nptl:

  • add patch fixing "undefined reference to TLS_DTPREL_VALUE/TLS_TPREL_VALUE"-problem when linking libdl dependent programs statically
  • patch taken from here
  • refs #1939

comment:48 Geändert vor 5 Jahren durch er13

In 10536:

uClibc-0.9.33.x:

  • add bunch of cherry picked upstream patches
  • refs #1939

comment:49 Geändert vor 5 Jahren durch Whoopie

In 10537:

  • fwmod: fix packages directory (tested with 7390 labor and 7170)
  • refs #1939, refs r10534

comment:50 Geändert vor 5 Jahren durch er13

@Whoopie: Danke fürs r10537 - habe ich übersehen.

@alle, die die Toolchain selbst bauen: wartet noch mit dem Bauen, einige Pakete bauen noch nicht, was auf die Fehler in der Toolchain zurückzuführen ist (ganz konkret, samba lässt sich nicht übersetzen). Fix habe ich schon, muss noch testen.

comment:51 Geändert vor 5 Jahren durch er13

In 10538:

toolchain/uClibc:

  • fix backtrace symbol is missing in libubacktrace.so
  • refs #1939

comment:52 Geändert vor 5 Jahren durch er13

In 10539:

samba:

  • fix build problems with uClibc versions containing libubacktrace
  • refs #1939, refs #2108

comment:53 Geändert vor 5 Jahren durch er13

libubacktrace-Probleme in der Toolchain selbst sollten mit r10538 behoben sein. Es kann jedoch sein, dass es noch ein paar Pakete gibt, die sich noch nicht übersetzen lassen und die Patches analog r10539 benötigen.

@alle, die mit dem Bauen gewartet haben: Danke - jetzt könnt Ihr wieder bauen ;-)

comment:54 Geändert vor 5 Jahren durch CarstenSchuette

Also bei mir baut samba noch nicht. Ist immer noch backtrace. Oder muss ich den Toolchain komplett neu bauen?

Linking non-shared library bin/libwbclient.a
Linking bin/samba_multicall
lib/util.o: In function `log_stack_trace':
util.c:(.text.log_stack_trace+0xc): undefined reference to `backtrace'
collect2: error: ld returned 1 exit status
make[1]: *** [bin/samba_multicall] Error 1
make[1]: Leaving directory `/home/cschuette/freetz/trunk/source/target-mips_gcc-4.7.3_uClibc-0.9.33.2-nptl/samba-3.6.14/source3'

ERROR: Build failed.
make: *** [source/target-mips_gcc-4.7.3_uClibc-0.9.33.2-nptl/samba-3.6.14/source3/bin/samba_multicall] Error 1
Zuletzt geändert vor 5 Jahren von CarstenSchuette (vorher) (Diff)

comment:55 Antwort: Geändert vor 5 Jahren durch er13

Hast Du nach r10538 uClibc und gcc-final neu gebaut? Offensichtlich nein. Am besten mit dem frischen checkout starten.

Edit: Solltest Du Dich dafür entscheiden, nicht alles, sondern nur uClibc und gcc-final neu zu bauen, so musst Du noch die config.cache löschen, damit Samba baut.

Zuletzt geändert vor 5 Jahren von er13 (vorher) (Diff)

comment:56 als Antwort auf: ↑ 55 Geändert vor 5 Jahren durch CarstenSchuette

Replying to er13:

Hast Du nach r10538 uClibc und gcc-final neu gebaut? Offensichtlich nein. Am besten mit dem frischen checkout starten.

Nein, habe ich nicht (läuft jetzt mal gucken). Erkennt der Toolchain neue Patches/Versionen nicht selbstständig?

comment:57 Geändert vor 5 Jahren durch er13

In 10545:

toolchain:

  • yet another try to provide (working) download-toolchain for uClibc-0.9.33/gcc-4.7 based firmwares (e.g. 7390/Labor)
  • refs #1939, refs #2103

comment:58 Geändert vor 5 Jahren durch er13

In 10616:

gcc-4.8.x:

comment:59 Geändert vor 5 Jahren durch er13

In 10723:

uClibc:

  • make it possible to compile uClibc with debug symbols included, useful for debugging (i.e. for developers only)
  • refs #1939

comment:61 Geändert vor 5 Jahren durch er13

In 10805:

uclibc-0.9.33.x:

  • add some upstream patches
  • refs #1939

comment:62 Geändert vor 5 Jahren durch er13

In 10806:

uclibc-0.9.33.x:

comment:63 Geändert vor 5 Jahren durch er13

In 10807:

gmp:

comment:64 Geändert vor 5 Jahren durch er13

In 10854:

uClibc-0.9.33.x:

  • add yet another upstream patch
  • refs #1939

comment:65 Geändert vor 5 Jahren durch er13

In 10946:

uClibc 0.9.28/0.9.29:

  • add backport of upstream patch fixing loader segmentation fault when RLD_MAP is 0 (by oliver, testing by chris56)
  • refs #1939
  • refs #706

comment:66 Geändert vor 5 Jahren durch er13

In 10947:

download-toolchains:

  • update download toolchains for uClibc-0.9.28, 0.9.29 and 0.9.33 based boxes
  • refs #1939
  • refs #706

Note: all users of these boxes should backup their .config, call "make distclean", restore their .config and build everything anew, i.e. no autoupdate or whatever…

comment:67 Geändert vor 5 Jahren durch er13

In 11090:

uClibc-0.9.33.x:

  • add three backtrace related patches submitted on uClibc mailing list
  • refs #1939

comment:68 Geändert vor 5 Jahren durch er13

In 11093:

download-toolchain:

  • provide uClibc-0.9.33 based download-toolchain for big-endian/uClibc-0.9.32.x/kernel-2.6.32.x based boxes - EXPERIMENTAL
  • refs #1939, refs #1942

comment:69 Geändert vor 5 Jahren durch er13

In 11094:

download-toolchain:

  • provide uClibc-0.9.33 based download-toolchain also for little-endian/uClibc-0.9.32.x/kernel-2.6.32.x based boxes - EXPERIMENTAL
  • refs #1939, refs #1942

comment:70 Geändert vor 5 Jahren durch er13

In 11159:

gmp:

comment:71 Geändert vor 5 Jahren durch er13

In 11160:

mpfr:

comment:72 Geändert vor 5 Jahren durch er13

In 11162:

gcc-4.8.x:

comment:73 Geändert vor 5 Jahren durch er13

In 11396:

binutils:

  • add upstream patch fixing 'multiple definition of _GLOBAL_OFFSET_TABLE_'-problem
  • refs #2095, refs #1939

comment:74 Geändert vor 5 Jahren durch er13

In 11397:

mpfr:

comment:75 Geändert vor 5 Jahren durch er13

In 11398:

binutils:

  • add experimental support for binutils-2.24.x
  • refs #1939
  • refs #2095

comment:76 Geändert vor 5 Jahren durch er13

In 11406:

gcc-4.8.x:

  • gcc-4.8.x is still experimental but not HIGHLY experimental anymore ;-)
  • refs #1939

comment:77 Geändert vor 5 Jahren durch er13

In 11416:

uClibc:

  • uClibc assumes --no-as-needed is the default linker option, add patches passing it explicitly - fixes various uClibc linking issues with --as-needed being the default (this is a defensive/low risk solution, a better one would be to tweak uClibc Makefiles and fix the order of parameters/libraries)
  • refs #2095, refs #1939

comment:78 Geändert vor 5 Jahren durch er13

In 11417:

uClibc:

comment:79 Geändert vor 5 Jahren durch er13

In 11418:

uClibc-0.9.33.x:

  • add more upstream patches
  • refs #1939, (maybe?) refs #1560

comment:80 Geändert vor 5 Jahren durch er13

In 11731:

uClibc-0.9.33.x/NPTL:

  • disable stack cache to save memory at run-time, patch taken from OpenWRT
  • refs #1939

comment:81 Geändert vor 4 Jahren durch er13

In 11969:

  • reflect recent final/labor releases in the build_download_toolchains-script
  • add gcc-4.8.x support
  • refs #1939

comment:82 Geändert vor 4 Jahren durch er13

In 11970:

mpfr:

comment:83 Geändert vor 4 Jahren durch er13

In 11971:

mpc:

comment:84 Geändert vor 4 Jahren durch er13

In 11972:

kernel-toolchain:

  • add support for gcc-4.8.x
  • refs #1939

download-toolchains:

  • provide gcc-4.8.x based download-toolchains

7490 labor:

  • use gcc-4.8.x based download-toolchains
  • refs r11968

comment:85 Geändert vor 4 Jahren durch dileks

Geändert vor 4 Jahren durch dileks

[PATCH] toolchain: update gcc-4.8.x version to 4.8.3

Geändert vor 4 Jahren durch dileks

My Freetz-config to test gcc-4.8.3 (dileks)

comment:86 Geändert vor 4 Jahren durch dileks

NOTE: Beyond the build-system changes only 000-no_target_flags_as_BUILD_FLAGS.freetz.patch (patch for gcc-4.8.3) required a refresh.

Geändert vor 4 Jahren durch dileks

[PATCH] toolchain: gcc-4.8.3: Fix 000-no_target_flags_as_BUILD_FLAGS.freetz.patch

Geändert vor 4 Jahren durch dileks

[PATCH] toolchain: update gcc-4.8.x version to 4.8.3 (v2)

comment:87 Geändert vor 4 Jahren durch er13

In 12052:

binutils/gcc:

  • simplify version bumping by removing minor-version-component from the name of the patches-dir
  • refs #1939

comment:88 Geändert vor 4 Jahren durch er13

In 12058:

gcc-4.8.x:

download-toolchain:

  • provide gcc-4.8.3 based download toolchain

comment:89 Geändert vor 4 Jahren durch er13

In 12139:

gcc-4.7.x:

  • bump version to 4.7.4
  • update gcc-4.7.x based download toolchain
  • refs #1939

comment:90 Geändert vor 4 Jahren durch er13

In 12252:

gmp:

comment:91 Geändert vor 4 Jahren durch er13

In 12253:

mpfr:

comment:92 Geändert vor 4 Jahren durch er13

In 12255:

uClibc++:

comment:93 Geändert vor 4 Jahren durch er13

In 12266:

target-toolchain:

comment:94 Geändert vor 4 Jahren durch er13

In 12343:

  • use 7390labor to build download-toolchain for uClibc-0.9.33.x/NPTL based boxes
  • refs #1939
  • refs #2519

comment:96 Geändert vor 4 Jahren durch er13

In 12410:

uClibc-0.9.33.x:

  • add some patches from openwrt
  • refs #1939

comment:97 Geändert vor 4 Jahren durch er13

In 12411:

uClibc-0.9.33.x:

  • rename some patches to document their origin
  • refs #1939

comment:98 Geändert vor 4 Jahren durch er13

In 12412:

uClibc-0.9.33.x:

comment:99 Geändert vor 4 Jahren durch er13

In 12413:

uClibc-0.9.33.x:

  • add some upstream patches
  • refs #1939

comment:100 Geändert vor 4 Jahren durch er13

In 12414:

uClibc-0.9.33.x:

  • auto-fix patches
  • refs #1939

comment:101 Geändert vor 4 Jahren durch er13

In 12415:

uClibc-0.9.33.x:

  • auto-fix one more patch
  • refs #1939

comment:102 Geändert vor 4 Jahren durch er13

In 12416:

uClibc-0.9.33.x:

  • rename some more patches to document their origin
  • refs #1939

comment:103 Geändert vor 4 Jahren durch er13

In 12417:

uClibc-0.9.33.x:

comment:104 Geändert vor 4 Jahren durch er13

In 12429:

uClibc-0.9.33.x:

  • remove one of the patches added in r12413 - it's too dependent on the kernel version, we still (have to) support 2.6.13 & 2.6.19
  • refs #1939

comment:105 Geändert vor 4 Jahren durch er13

In 12430:

gcc:

comment:106 Geändert vor 4 Jahren durch er13

In 12433:

target-gcc:

  • make '—as-needed' the default linker option for uClibc versions ≥ 0.9.32
  • refs #2095, refs #1939

comment:107 Geändert vor 4 Jahren durch er13

In 12441:

uClibc-0.9.33.x/NPTL:

comment:108 Geändert vor 4 Jahren durch er13

In 12442:

download-toolchains:

comment:109 Geändert vor 4 Jahren durch er13

In 12443:

download-toolchain for uClibc-0.9.33/NPTL based boxes:

  • revert parts of r12342, accept4-version contained within the download-toolchain from r12442 works with all kernel versions
  • refs #2519, refs #1939

comment:111 Geändert vor 4 Jahren durch er13

In 12492:

uClibc-0.9.33:

  • add fallocate/posix_fallocate related upstream patches
  • refs #1939

comment:112 Geändert vor 4 Jahren durch er13

In 12694:

gcc-4.9.x:

comment:113 Geändert vor 4 Jahren durch er13

In 12760:

uClibc-0.9.33.x:

  • add resolver related patches provided by Mathias Kresin on the uClibc mailing list: #1, #2
  • refs #1560, refs #1939

comment:114 Geändert vor 4 Jahren durch er13

In 12763:

gcc-4.8/4.9:

  • add support for building gcc versions based on (weekly) snapshots
  • refs #1939

comment:115 Geändert vor 4 Jahren durch er13

In 12776:

gcc:

  • bump default snapshot versions to the latest ones
  • refs #1939

comment:116 Geändert vor 4 Jahren durch er13

In 12793:

gcc:

  • bump default snapshot versions to the latest ones
  • refs #1939

comment:117 Geändert vor 4 Jahren durch er13

In 12821:

gcc:

  • bump default snapshot versions to the latest ones
  • refs #1939

comment:118 Geändert vor 4 Jahren durch er13

In 12822:

gcc-4.8.x:

  • bump version to 4.8.4
  • provide updated, gcc-4.8.4 based download toolchain
  • refs #1939

Note: all users using gcc-4.8.x based toolchain (doesn't matter download or self-built) should backup their .config, call "make distclean", restore their .config and build everything anew, i.e. no autoupdate or whatever…

comment:119 Geändert vor 4 Jahren durch er13

In 12839:

kernel-gcc:

  • add explicit default for the float mode (use the same one as for the target gcc)
  • refs #1939

comment:120 Geändert vor 4 Jahren durch er13

In 12840:

binutils:

  • add preliminary and highly-experimental support for binutils-2.25, refs #1939
  • DOES NOT WORK YET because of "soft- vs. hardfloat"-problem. i.e.

a lot of warnings while compiling gcc

{standard input}: Assembler messages:
{standard input}: Warning: .gnu_attribute 4,3 requires `softfloat'

a lot of warnings while compiling uClibc and target packages, e.g.

mips-linux-uclibc/bin/ld: Warning: lib/ld-uClibc-0.9.33.2.so uses -msoft-float (set by ldso/ldso/ld-uClibc_so.a(ldso.oS)), ldso/ldso/ld-uClibc_so.a(resolve.oS) uses -mhard-float

comment:121 Geändert vor 4 Jahren durch er13

TODO: backport this patch (upstream commit) to 2.6.28/2.6.32 or disable binutils-2.25 for kernel-toolchain.

TODO2: rework arch/cpu/fpu-flags like described in Linaro FAQ

TODO3: understand this binutils commit (it's the root cause of all these soft- vs. hard-float warnings)

Zuletzt geändert vor 4 Jahren von er13 (vorher) (Diff)

comment:122 Geändert vor 4 Jahren durch er13

In 12843:

gcc/binutils:

  • revise configure options (step 1, more to come): in particular remove --with-march (there is --with-arch but no --with-march) and --enable-cxx-flags
  • ensure -msoft-float is passed both to the compiler and to the assembler - fixes binutils-2.25 related build problems for target toolchain (kernel toolchain is still a TODO)
  • refs #1939

Note: after updating to this revision you will get the following error

configure: error: `CFLAGS/CXXFLAGS' has changed since the previous run:
configure:   former value:  `-march=4kc/24kc -Os -pipe -Wa,--trap -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64'
configure:   current value: `-march=4kc/24kc -msoft-float -Wa,-msoft-float -Os -pipe -Wa,--trap -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64'

This is because float-abi related options have been adjusted. Please call sed -i -e 's|4kc -Os|4kc -msoft-float -Wa,-msoft-float -Os|g' source/target-mips*_gcc-*_uClibc-*/config.cache in order to fix the values cached in config.cache.

comment:123 Geändert vor 4 Jahren durch er13

In 12844:

gcc:

  • remove unnecessary --with-march related code (committed in r12843 for documentation purpose)
  • refs #1939

comment:124 Geändert vor 4 Jahren durch er13

In 12845:

gcc:

  • remove unnecessary --enable-cxx-flags related code (committed in r12843 for documentation purpose)
  • refs #1939

comment:125 Geändert vor 4 Jahren durch er13

In 12847:

kernel-binutils:

  • disable mutlilib explicitly
  • refs #1939

comment:126 Geändert vor 4 Jahren durch er13

In 12848:

kernel-/target-binutils:

  • remove --enable-softfloat option added in r12843 - it doesn't make sense to use it for a single-purpose toolchain (i.e. non-multilib toolchain). In a multilib environment this option specifies if a soft-float-lib should be built alongside with the hard-float-one.
  • refs #1939, ref r12843

comment:127 Geändert vor 4 Jahren durch er13

In 12849:

kernel-gcc:

  • disable multilib explicitly
  • refs #1939

comment:128 Geändert vor 4 Jahren durch er13

In 12852:

toolchain/gcc:

  • revise arch/cpu/tune/float-abi related configure options and compiler flags once again (unfortunately we're still not finished)
  • introduce config/mod/compiler.in - a single point of control of all arch/cpu/tune/float-abi related settings (up to now these were spread over makefiles and uClibc-patches with hardcoded values)
  • the flags are almost the same as those used before r12843 - this way we fix/workaround the build problems caused by -Wa,-msoft-float (s. #2659) but break binutils-2.25 again (I'm still uncertain if gas from binutils-2.25 is broken for MIPS or we compile the toolchain in a wrong way, TBD)
  • refs #1939, refs #2659

Note: after updating to this revision you will get the following error

configure: error: `CFLAGS/CXXFLAGS' has changed since the previous run:
configure:   former value: ...
configure:   current value: ...

Please call sed -i -r -e '/ac_cv_env_C(XX)?FLAGS_value/ d' source/target-mips*_gcc-*_uClibc-*/config.cache in order to remove the values cached in config.cache.

comment:129 Geändert vor 4 Jahren durch er13

In 12853:

uClibc:

comment:130 Geändert vor 3 Jahren durch er13

In 12994:

uClibc:

comment:131 Geändert vor 3 Jahren durch er13

In 12997:

binutils:

  • downgrade default binutils version, use 2.22 by default for all compiler versions
  • AVM uses 2.21 (at least upto Fritz!OS 6.24), call grep "^BR2_BINUTILS_VERSION" buildroot.config* within unpacked opensrc package to verify
  • refs #1939

comment:132 Geändert vor 3 Jahren durch er13

In 13003:

uClibc:

comment:133 Geändert vor 3 Jahren durch er13

In 13005:

[uclibc-testing branch]:

  • update uClibc-0.9.33.x based download toolchains
  • refs #1939, refs #2499, refs #2547

comment:134 Geändert vor 3 Jahren durch er13

In 13007:

[trunk]:

Note: all users of uClibc-0.9.33.2 based toolchain (both download and self-built) should backup their .config, call "make distclean", restore their .config and build everything anew, i.e. no autoupdate or whatever…

comment:135 Geändert vor 3 Jahren durch er13

In 13181:

gcc-4.8.x:

  • bump version to 4.8.5
  • provide updated, gcc-4.8.5 based download toolchain
  • refs #1939


Note: all users using gcc-4.8.x based toolchain (doesn't matter download or self-built) should backup their .config, call "make distclean", restore their .config and build everything anew, i.e. no autoupdate or whatever…

comment:136 Geändert vor 3 Jahren durch er13

In 13188:

gcc-4.9.x:

comment:137 Geändert vor 3 Jahren durch er13

In 13189:

gcc-4.8.x/4.9.x:

  • update default snapshot version to a more recent one (untested)
  • refs #1939

comment:139 Geändert vor 3 Jahren durch er13

In 13324:

binutils-2.25.x:

  • bump version to 2.25.1
  • refs #1939

comment:140 Geändert vor 3 Jahren durch er13

In 13325:

"binutils-2.25.x / MIPS / soft-float"-problem:

comment:141 Geändert vor 3 Jahren durch er13

In 13326:

libffi:

comment:142 Geändert vor 3 Jahren durch er13

In 13327:

binutils-2.24.x/2.25.x:

  • change status from EXPERIMENTAL to regular
  • refs #1939

comment:143 Geändert vor 3 Jahren durch er13

In 13336:

gcc-4.9.x:

  • change status from EXPERIMENTAL to regular
  • refs #1939

comment:144 Geändert vor 3 Jahren durch er13

In 13518:

uClibc:

  • add three (posix_)fallocate related patches from the uClibc mailing list: 1, 2, 3
  • refs #1939

comment:145 Geändert vor 3 Jahren durch er13

In 13525:

mpfr:

comment:146 Geändert vor 3 Jahren durch er13

In 13541:

uClibc-0.9.33.x:

  • fix ldd on 64-bit host for uClibc-0.9.33.x (this is the same fix as that added for uClibc-0.9.29 in r11859 and for uClibc-0.9.32.x in r11860)
  • for some reason it was missing for uClibc-0.9.33.x
  • based on this uclibc-ng commit (which in turn is based on Ralf's code committed in the changesets mentioned above)
  • refs #842, refs #1939

comment:147 Geändert vor 3 Jahren durch er13

In 13542:

uClibc-0.9.29/uClibc-0.9.32:

comment:148 Geändert vor 3 Jahren durch er13

In 13543:

uClibc-0.9.33:

  • add a patch fixing a memory leak in canonicalize_file_name (taken from uclibc-ml)
  • refs #1939

comment:149 Geändert vor 3 Jahren durch er13

In 13614:

binutils:

  • add support for binutils-2.26.x
  • refs #1939

comment:150 Geändert vor 2 Jahren durch er13

In 13649:

mpfr:

comment:151 Geändert vor 2 Jahren durch er13

In 13747:

mpfr:

comment:152 Geändert vor 2 Jahren durch er13

In 13748:

download-toolchain:

  • update download-toolchain for all targets
  • provide download-toolchain for kernel-3.10.x based firmwares
  • refs #1939, refs #2774, refs #2797

NOTE: all users using download-toolchain should backup their .config, call make distclean, copy their .config back and build everything anew after updating to this revision, i.e. no autoupdate or whatever…

comment:153 Geändert vor 2 Jahren durch er13

In 13866:

gcc-4.9.x:

comment:154 Geändert vor 2 Jahren durch er13

In 13868:

binutils-2.26.x:

  • bump version to 2.26.1
  • refs #1939

comment:155 Geändert vor 2 Jahren durch er13

In 13884:

tichksum:

  • workaround lseek(fd, negative offset, SEEK_END) doesn't work on the target
  • most likely a uClibc issue, we probably need to backport some of the following commits: lseek, llseek
  • refs #1939

comment:156 Geändert vor 2 Jahren durch dileks

What about switching over to uClibc-ng as a replacement for "inactive" uClibc?
Projects like buildroot and others did so.

comment:157 Geändert vor 2 Jahren durch er13

Some people do make search before asking questions.

comment:158 Geändert vor 2 Jahren durch dileks

Thanks for pointing to ticket #2816.

But what do you mean?

Did you try uClibc-ng in the Freetz build-system?
Does it reduce the amount of own maintained patches?

Does AVM use now uClibc-ng in their modern firmware-versions?

What are the plans of Freetz?
Support both uClibc and uClibc-ng?

What about pushing patches required for Freetz to uClibc-ng?

comment:159 Geändert vor 20 Monaten durch er13

In 14010:

toolchain:

  • remove FREETZ_TARGET_LFS menuconfig symbol
  • from now LFS is always enabled (default so far) and could not be disabled [reasons: a) not supported for all packages anyway, b) AVM's toolchain is LFS-enabled]
  • refs #1939

comment:160 Geändert vor 20 Monaten durch er13

In 14011:

build system:

  • reorder some define's - no functional changes
  • refs #1939

comment:161 Geändert vor 18 Monaten durch er13

In 14109:

toolchain:

  • add EXPERIMENTAL support for gcc-5.x
  • refs #1939, refs #2885

comment:162 Geändert vor 15 Monaten durch er13

In 14287:

toolchain:

  • provide download toolchain for boxes which firmware is built using gcc-5.x (7560, 7580, 7590)
  • refs #1939, refs #2885

comment:163 Geändert vor 5 Monaten durch er13

In 14612:

gcc-5.x series:

  • bump version to 5.5.0
  • update download toolchain
  • refs #1939
Hinweis: Hilfe zur Verwendung von Tickets finden Sie in TracTickets.